Hi! Pull requests are welcome and always respected.

If the PR is a big one, or adds a new feature, please open an issue to ask questions first.

We promise to avoid pedantic or cosmetic disputes!

### To get it running:
* [fork](https://help.github.com/articles/fork-a-repo/) the repository
* [clone](https://help.github.com/articles/cloning-a-repository/) it to your computer

```bash
cd spacetime
npm install
npm test
```

### Making changes
* make your changes in `./src`
* make sure the tests still pass `npm test`
* for bonus points - add a few tests in `./tests` (doesn't matter where) for the new behaviour

* create a [Pull Request](https://help.github.com/articles/creating-a-pull-request-from-a-fork/)

don't worry about incrementing package numbers, or kicking-off builds. Releases will be handled by the maintainers.

Lastly, thank you! A usable timezone library in the browser is serious and important project.

It's done collaboratively or badly!

### Agreement to the Begin Community Code of Conduct
By participating and contributing to the Small Wins (aka Begin) community -- including, but not limited to its open source projects, any related online venues such as Github, Slack, and in-person events, etc. -- you agree to the [Begin Code of Conduct](https://github.com/smallwins/policy/blob/master/begin-community-code-of-conduct.md), found at the [Begin Policy archive](https://github.com/smallwins/policy). Lack of familiarity with this Code of Conduct is not an excuse for not adhering to it.
